/*
 *  Header file for sendCW
 */

/* #Defines and Header Files */
#define ON   1
#define OFF  0

#define TRUE 1
#define FALSE !TRUE

#define DIT '.'
#define DAH '-'

#define MAX_LETTERS 512
#define _USE_BSD

#define SC_TONE_ON 2
#define PC_TONE_ON 1

#define FARNS_OFF  4

#include "cwlib.h"
#include <math.h>
#include <stdlib.h>
#include <unistd.h>	
#include <sys/kd.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/resource.h>

//PPC
#include <string.h>
#include <sys/types.h>
#include <sys/shm.h>

/* 
 * Global Variables
 */
int  qid;                               /* Message queue id */
int  confd;                             /* File descriptor for sidetone */
int  serfd;                             /* File descriptor for serial port */
int  tone;                              /* To be adjustable */
int  wpm;                               /* Speed in WPM */
unsigned char *letters[MAX_LETTERS]    ; /* Array for morse characters */

int fwpm;                               /* Farnsworth gap (WPM) */

int key_mode;

long  dit_time;                         /* Dit time in uSEC */
long  dah_time;                         /* Dah time in uSEC */
long  ic_time;                          /* Intra char time == dit_time */
long  il_time;                          /* Inter char time == dah_time */
long  iw_time;                          /* Inter word time == 7 * dit_time*/
  
/*
 * Function Declarations
 */
void initialize (char *ser_dev);
void cleanup ();
void setWPM (int wpm);
void setFarns (int fwpm);
void setTone (int new_tone);
void setSidetone (int new_tone);
void doWord (unsigned char[]);
void doLetter (char[]);
void keyRTS (int time);
void timer (long usec);
pid_t wait4 (pid_t, int *, int, struct rusage *);   /*Why?*/
void keyed (int state);

/*
 * CWirc stuff
 */
#define AUDIOBUF_SIZE		22050   /* Samples */

struct cwirc_extension_api {
        int semid;
        signed short int out_audiobuf[AUDIOBUF_SIZE];
        int out_audiobuf_start;
        int out_audiobuf_end;
        int in_key;
        int pid;
};

extern int do_cwirc;
extern struct cwirc_extension_api *cwirc_api_shm;
