/*
 * twcw:  A gui application that sends Morse Code 
 * Copyright (C) 1997 Ted Williams WA0EIR 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Version: 1.2 APR 2004
 */

/*
 * Dialogs for twcw
 */

/*
 * Prompt dialog - used to enter text at an '*' when sending a file
 */
#include "common.h"
#include "twcw.h"

void inputDiag (char *word)
{
   static Widget promptDiag;
   XmString msg_xs;
   XmString textField;

   if (promptDiag == NULL)
   {
      promptDiag = XmCreatePromptDialog (shell, "promptDiag", (ArgList) NULL, 0);
      XtUnmanageChild (XmSelectionBoxGetChild (promptDiag, XmDIALOG_HELP_BUTTON));
      XtAddCallback (promptDiag, XmNokCallback, OkCB, (XtPointer) NULL);
      XtAddCallback (promptDiag, XmNcancelCallback, cancelCB, (XtPointer) NULL);
   }
   XtVaSetValues (XtParent (promptDiag),
      XmNtitle, "TWCW Prompt Dialog",
      NULL);

   msg_xs = XmStringCreateLocalized (word);
   textField = XmStringCreateLocalized ("");
   XtVaSetValues (promptDiag,
      XmNtextString, textField,
      XmNselectionLabelString, msg_xs,
      NULL); 
   XmStringFree (msg_xs);
   XmStringFree (textField);
   XtManageChild (promptDiag);
}

/*
 * OK Callback for promptDiag
 */

void OkCB (Widget w, XtPointer cldata, XtPointer cbdata)
{
   char *words, *sendwords;
   XmTextPosition cur_pos;
   int len;
   XmSelectionBoxCallbackStruct *cbs = (XmSelectionBoxCallbackStruct *) cbdata;

   XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &words);

   len = strlen (words);

   sendwords = XtMalloc (strlen (words) + 2);
   strcpy (sendwords, words);
   sendwords[len] = ' ';               /* Replace the space that was deleated */
   sendwords[len+1] = '\0';

   cur_pos = XmTextGetLastPosition (txText);
   XmTextSetInsertionPosition (txText, cur_pos);
   XmTextInsert (txText, cur_pos, sendwords);
   XtFree (sendwords);
                                       /* Now reschedule the work proc */
   XtAppAddWorkProc (ac, procData, (XtPointer) NULL);
}


/*
 * Cancel Callback for promptDiag
 */

void cancelCB (Widget w, XtPointer cldata, XtPointer cbdata)
{
   XtAppAddWorkProc (ac, procData, (XtPointer) NULL);
}


/*
 * aboutDiag Function
 * Just an info dialog
 */
void aboutCB (Widget w, XtPointer cldata, XtPointer cbdata)
{
   static Widget diag = NULL;
   XmString  msg_xs;
   char msg_str[] = "twcw \251 1998 was written by\nTed Williams - WA\330EIR";

   msg_xs = XmStringCreateLtoR (msg_str, XmFONTLIST_DEFAULT_TAG);
   if (diag == NULL)
      {
      diag = XmCreateInformationDialog (shell, "aboutDiag",  (ArgList) NULL, 0);
      XtVaSetValues (XtParent(diag),
         XmNtitle, "ABOUT TWCW",
         NULL);

      XtVaSetValues (diag,
         XmNmessageAlignment, XmALIGNMENT_CENTER,
         XmNmessageString, msg_xs,
         NULL);
      XmStringFree(msg_xs);

      XtUnmanageChild (XmMessageBoxGetChild (diag, XmDIALOG_CANCEL_BUTTON));
      XtUnmanageChild (XmMessageBoxGetChild (diag, XmDIALOG_HELP_BUTTON));
      }
   XtManageChild (diag);
}
